#include<bits/stdc++.h>
using namespace std;
const int nmax=36;
int n,f[nmax],mark[nmax],lab,debug=0;
vector<int> e[nmax],Q;

int diameter(){
    int res=0;
    for (int u=0;u<=n;u++){
        Q.clear();
        Q.push_back(u);
        mark[u]=++lab;
        f[u]=0;
        for (int i=0;i<Q.size();i++){
            int x=Q[i];
            for (int j=0;j<e[x].size();j++){
                int y=e[x][j];
                if (mark[y]!=lab){
                    mark[y]=lab;
                    f[y]=f[x]+1;
                    res=max(res,f[y]);
                    Q.push_back(y);
                }
            }
        }
    }
    if (debug) printf("diameter when n=%d is %d\n",n,res);
    return res;
}

void addRoad(int u,int v){
    if (debug) printf("adding %d,%d...: ",u,v);
    e[u].push_back(v);
    e[v].push_back(u);
    if (debug) printf("It's ok when add %d,%d\n",u,v);
}

void removeRoad(int u,int v){
    if (debug) printf("removing %d,%d...: ",u,v);
    for (int i=0;i<e[u].size();i++)
    if (e[u][i]==v){
        e[u][i]=e[u].back();
        e[u].pop_back();
        break;
    }
    for (int i=0;i<e[v].size();i++)
    if (e[v][i]==u){
        e[v][i]=e[v].back();
        e[v].pop_back();
        break;
    }
    if (debug) printf("It's ok when remove %d,%d\n",u,v);
}

void printResult(){
    for (int i=0;i<n;i++)
        for (int j=0;j<e[i].size();j++)
            if (i<e[i][j]) cout<<i<<" "<<e[i][j]<<endl;
    //cout<<diameter()<<endl;
}

main(){
    n=3;
    addRoad(0,1);
    addRoad(0,2);
    addRoad(0,3);
    addRoad(1,2);
    addRoad(1,3);
    addRoad(2,3);
    while (n<nmax-1){
        int u=++n,v=++n,bestDiameter=1000000000,bx,by,bz,bt;
        if (debug) printf("Solve n=%d\n",n);
        addRoad(u,v);
        for (int x=0;x<n-2;x++){

            vector<int> ex=e[x];
            //ex.clear();
            //for (int i=0;i<e[x].size();i++) ex.push_back(e[x][i]);

            for (int i=0;i<ex.size();i++){
                int y=ex[i];
                if (x<y) continue;
                for (int z=0;z<n-2;z++){

                    vector<int> ez=e[z];
                    //ez.clear();
                    //for (int i=0;i<e[z].size();i++) ez.push_back(e[z][i]);

                    for (int i=0;i<ez.size();i++){
                        int t=ez[i];
                        if (z<t || (z==x && t==y)) continue;
                        removeRoad(x,y);
                        addRoad(x,u);
                        addRoad(u,y);//
                        removeRoad(z,t);
                        addRoad(z,v);
                        addRoad(v,t);
                        int newDiameter=diameter();
                        if (debug) printf("bestD=%d, newD=%d\n",bestDiameter,newDiameter);
                        if (newDiameter<bestDiameter){
                            bestDiameter=newDiameter;
                            bx=x,by=y,bz=z,bt=t;
                        }
                        removeRoad(x,u);
                        removeRoad(u,y);
                        addRoad(x,y);//
                        removeRoad(z,v);
                        removeRoad(v,t);
                        addRoad(z,t);
                    }
                }
            }
        }
        removeRoad(bx,by);
        addRoad(bx,u);
        addRoad(u,by);
        removeRoad(bz,bt);
        addRoad(bz,v);
        addRoad(v,bt);
    }
    printResult();
}
